org.springframework.web.reactive

## Interface HandlerMapping

- All Known Implementing Classes:
    AbstractHandlerMapping, AbstractHandlerMethodMapping, AbstractUrlHandlerMapping, RequestMappingHandlerMapping, RequestMappingInfoHandlerMapping, RouterFunctionMapping, SimpleUrlHandlerMapping

      public interface HandlerMapping

  Interface to be implemented by objects that define a mapping between requests and handler objects.
  Since:
    5.0
  Author:
    Rossen Stoyanchev, Sebastien Deleuze

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BEST_MATCHING_HANDLER_ATTRIBUTE` Name of the `attribute` that contains the mapped handler for the best matching pattern.
    `static String` | `BEST_MATCHING_PATTERN_ATTRIBUTE` Name of the `attribute` that contains the best matching pattern within the handler mapping.
    `static String` | `MATRIX_VARIABLES_ATTRIBUTE` Name of the `attribute` that contains a map with URI variable names and a corresponding MultiValueMap of URI matrix variables for each.
    `static String` | `PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE` Name of the `attribute` that contains the path within the handler mapping, in case of a pattern match such as `"/static/**"` or the full relevant URI otherwise.
    `static String` | `PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE` Name of the `attribute` containing the set of producible MediaType's applicable to the mapped handler.
    `static String` | `URI_TEMPLATE_VARIABLES_ATTRIBUTE` Name of the `attribute` that contains the URI templates map mapping variable names to values.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `reactor.core.publisher.Mono<Object>` | `getHandler(ServerWebExchange exchange)` Return a handler for this request.

- - ### Field Detail

    - #### BEST_MATCHING_HANDLER_ATTRIBUTE

          static final String BEST_MATCHING_HANDLER_ATTRIBUTE

      Name of the `attribute` that contains the mapped handler for the best matching pattern.

    - #### BEST_MATCHING_PATTERN_ATTRIBUTE

          static final String BEST_MATCHING_PATTERN_ATTRIBUTE

      Name of the `attribute` that contains the best matching pattern within the handler mapping.

    - #### PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE

          static final String PATH_WITHIN_HANDLER_MAPPING_ATTRIBUTE

      Name of the `attribute` that contains the path within the handler mapping, in case of a pattern match such as `"/static/**"` or the full relevant URI otherwise.

      Note: This attribute is not required to be supported by all HandlerMapping implementations. URL-based HandlerMappings will typically support it but handlers should not necessarily expect this request attribute to be present in all scenarios.

    - #### URI_TEMPLATE_VARIABLES_ATTRIBUTE

          static final String URI_TEMPLATE_VARIABLES_ATTRIBUTE

      Name of the `attribute` that contains the URI templates map mapping variable names to values.

      Note: This attribute is not required to be supported by all HandlerMapping implementations. URL-based HandlerMappings will typically support it, but handlers should not necessarily expect this request attribute to be present in all scenarios.

    - #### MATRIX_VARIABLES_ATTRIBUTE

          static final String MATRIX_VARIABLES_ATTRIBUTE

      Name of the `attribute` that contains a map with URI variable names and a corresponding MultiValueMap of URI matrix variables for each.

      Note: This attribute is not required to be supported by all HandlerMapping implementations and may also not be present depending on whether the HandlerMapping is configured to keep matrix variable content in the request URI.

    - #### PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE

          static final String PRODUCIBLE_MEDIA_TYPES_ATTRIBUTE

      Name of the `attribute` containing the set of producible MediaType's applicable to the mapped handler.

      Note: This attribute is not required to be supported by all HandlerMapping implementations. Handlers should not necessarily expect this request attribute to be present in all scenarios.

  - ### Method Detail

    - #### getHandler

          reactor.core.publisher.Mono<Object> getHandler(ServerWebExchange exchange)

      Return a handler for this request.

      Before returning a handler, an implementing method should check for CORS configuration associated with the handler, apply validation checks based on it, and update the response accordingly. For pre-flight requests, the same should be done based on the handler matching to the expected actual request.

      Parameters:
        `exchange` - current server exchange
      Returns:
        a `Mono` that emits one value or none in case the request cannot be resolved to a handler